# -*- coding:Utf-8 -*-

import os
import psyco
from random import Random
from socket import *
import threading
import es
import gamethread
import langlib
import playerlib
import popuplib
from redirectlib import Redirect
from colormsglib import ColorMsg
from es import server_var

psyco.full()

info = es.AddonInfo()
info.name = "redirection"
info.version = "2.4"
info.author = "EmbouT"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=24216"
info.description = "Redirects a player on another server (password supported)"

es.ServerVar(info.name, info.version, 'public var').makepublic()
saycmd = es.ServerVar('redirection_saycmd')
menukick = es.ServerVar('redirection_menukick')
maxplayers = es.ServerVar('redirection_maxplayers')
reserveslot = es.ServerVar('redirection_exclude_admins')
hazard = es.ServerVar('redirection_random')
sendmenu = es.ServerVar('redirection_sendmenu')
forceredirect = es.ServerVar('redirection_forceredirect')
kick = es.ServerVar('redirection_kick')
temps = es.ServerVar('redirection_time')
menuselect = es.ServerVar('redirection_menuselect')
vip = es.ServerVar('redirection_vip')
admin = server_var.getObject('BASIC_AUTH_ADMIN_LIST')


servergroup = {}
plist = []
exclude = set()
lang = None

def es_map_start(event_var):
    global lang ,lang_default, servergroup, exclude
    unload()
    servergroup = {}
    lang = {}
    exclude.clear()
    path = es.getAddonPath('redirection') + '/redirection_languages.ini'
    if os.path.isfile(path):
        lang = langlib.Strings(path)
        path = es.getAddonPath('redirection') + '/redirection.cfg'
        if os.path.isfile(path):
            es.mexec('../addons/eventscripts/redirection/redirection.cfg')
            if not es.exists('command', 'serveradd'):
                es.regcmd('serveradd', 'redirection/serveradd_cmd', ' Console command to add server. Syntax : serveradd <"ip:port"> ["server password"]')
            gamethread.delayed(0.5, init)
            gamethread.delayed(0.8, get_serverinfo)
        else:
            es.dbgmsg(0,'[redirection] Unable to load redirection.cfg! Please ensure it is in the ../redirection/ directory.')
            gamethread.delayed(0.1, es.unloadModuleAddon, ('redirection'))
    else:
        es.dbgmsg(0,'[redirection] Unable to load redirection_languages.ini! Please ensure it is in the ../redirection/ directory.')
        gamethread.delayed(0.1, es.unloadModuleAddon, ('redirection'))

def init():
    global exclude
    for steamid in str(admin).split(';'):
        exclude.add(steamid)
    for steamid in str(vip).split(';'):
        exclude.add(steamid)
    if not str(saycmd) == '0':
        if not es.exists('saycommand', str(saycmd)):
            es.regsaycmd(str(saycmd), 'redirection/say_cmd', "Custom say command to display servers menu")


def serveradd_cmd():
    global servergroup
    def testip(h):
        try:
            i = h.split(":")
            int(i[1])
            for x in i[0].split("."):
                int(x)
        except:
            return False
        return True
    argc = es.getargc()
    if argc in (2,3):
        server = es.getargv(1)
        password = ''
        if argc == 3:
            password = es.getargv(2)
            if password == '0':
                password = ''
        if testip(server):
            servergroup[len(servergroup)] = {'server': server,
                                             'password': password,
                                             'name': '',
                                             'place': (0,0),
                                             'dispo': [0,0]}
            if not str(saycmd) == '0' or not str(sendmenu) == '0':
                createmenu()
        else:
            es.dbgmsg(0, '[redirection] %s is an invalid IP adress!' % server)
    else:
        es.dbgmsg(0, '[redirection] Syntax Error !')
        es.dbgmsg(0, '[redirection] Syntax : serveradd <ip:port> ["server password"]')

def say_cmd():
    userid = es.getcmduserid()
    if servergroup:
        popuplib.send('redirection_server_menu_page_1', userid)
        es.playsound(userid, "buttons/combine_button7.wav", 1.0)
    else:
        ColorMsg("#green[redirection]#red " + lang('noserver', None, playerlib.getPlayer(userid).get('lang'))).tell(userid)

def createmenu():
    global servergroup
    menu = {}
    spp = 0
    spc = 0
    m = 0
    for s in servergroup:
        if spp == 5:
            spp=0
        if spp == 0:
            spc += 1
            if spc > 1:
                menu[m].addlineAll('-'*30)
                menu[m].addline(popuplib.langstring('->8. ', lang['prev']))
                menu[m].addline(popuplib.langstring('->9. ', lang['next']))
                menu[m].addline(popuplib.langstring('0. ', lang['quit']))
                spc -= 2
                menu[m].submenu(8, 'redirection_server_menu_page_%i' % spc)
                spc += 2
                menu[m].submenu(9, 'redirection_server_menu_page_%i' % spc)
                menu[m].enablekeys = mek + '89'
                menu[m].menuselect = menu_select
            if popuplib.exists('redirection_server_menu_page_%i' % spc):
                popuplib.delete('redirection_server_menu_page_%i' % spc)
            m += 1
            mek = '0'
            menu[m] = popuplib.create('redirection_server_menu_page_%i' % spc)
            menu[m].addline(popuplib.langstring('', lang['title']))
            menu[m].addlineAll('-------------------------------')
        spp += 1
        mek += str(spp)
        servergroup[s]['place'] = (spc, spp + 2)
        menu[m].addlineAll('->%i. %s (%i/%i)' % (spp, servergroup[s]['name'], servergroup[s]['dispo'][0], servergroup[s]['dispo'][1]))
        menu[m].menuvalue('redirection_menuselect', spp, s)


    if spc > 1:
        menu[m].addlineAll('-------------------------------')
        menu[m].addline(popuplib.langstring('->8. ', lang['prev']))
        menu[m].addline(popuplib.langstring('->9. ', lang['first']))
        menu[m].addline(popuplib.langstring('0. ', lang['quit']))
        spc -= 1
        menu[m].submenu(8, 'redirection_server_menu_page_%i' % spc)
        spc += 1
        menu[m].submenu(9, 'redirection_server_menu_page_1')
        menu[m].enablekeys = mek + '89'
        menu[m].menuselect = menu_select
        menu[1].modline(9, popuplib.langstring('->8. ', lang['last']))
        menu[1].submenu(8, 'redirection_server_menu_page_%i' % spc)
        i = 1
        while i <= spc:
            menu[i].modline(1, popuplib.langstring('', lang['title2'], ' %i/%i' % (i, spc)))
            i += 1
    elif spc == 1:
        menu[1].addlineAll('-------------------------------')
        menu[1].addline(popuplib.langstring('0. ', lang['quit']))
        menu[1].enablekeys = mek
        menu[1].menuselect = menu_select

def menu_select(userid, choix, menuname):
    if choix < 10:
        es.playsound(userid, "buttons/button14.wav", 1.0)
        if choix < 6:
            redirectplayer(userid, int(menuselect), 1)
            gamethread.cancelDelayed('redirectionforce%s' % userid)
    else:
        es.playsound(userid, "buttons/combine_button7.wav", 1.0)

def redirectplayer(userid, s, m=0):
    k = int(kick)
    if m:
        k = int(menukick)
    Redirect(servergroup[s]['server'], servergroup[s]['password'], k, float(temps)).send(userid)


def redirectforce(userid):
    p = popuplib.active(userid)
    if p['name']:
        popuplib.close(p['name'], userid)
        redirectplayer(userid, Random().randint(0, len(servergroup) -1 )if int(hazard) else 0)

def player_activate(event_var):
    global exclude
    if servergroup:
        userid = event_var['userid']
        l = playerlib.getPlayer(userid).get('lang')
        if maxplayers < es.getplayercount():
            a = 0
            if int(reserveslot):
                if event_var['es_steamid']in exclude:
                    lastplayer = foundlastplayer(userid)
                    a = 1 if lastplayer == userid else 2
                    userid = lastplayer
            if int(sendmenu):
                popuplib.send('redirection_server_menu_page_1', userid)
                gamethread.delayedname(int(forceredirect), 'redirectionforce%s' % userid, redirectforce, userid)
            else:
                redirectplayer(userid, Random().randint(0, len(servergroup) - 1) if int(hazard) else 0)
            if a == 2:
                ColorMsg("#green[redirection] #blue%s" % lang('admin arrive', {'username': event_var['es_username']}, l)).tell(userid)
                ColorMsg("#green[redirection] #red%s" % lang('give place', None, l)).tell(userid)
            elif a==1:
                ColorMsg("#green[redirection]#lightgreen%s" % lang('admin only'), None, l).tell(userid)
            else:
                ColorMsg("#green[redirection]#lightgreen%s" % lang('server full',None,l)).tell(userid)
        elif int(reserveslot):
            if not event_var['es_steamid']in exclude:
                plist.append(userid)

def foundlastplayer(user):
    if plist:
        userid = plist.pop()
        if not es.exists('userid',userid):
            foundlastplayer(user)
        else:
            return userid
    else:
        return user

def infoserveur(s):
    global serveurgroup
    def getdata(data):
        x = {}
        if data:
            x['hostname'] = getstr(data)
            data = data[len(x['hostname'])+1:]
            x['map'] = getstr(data)
            data = data[len(x['map'])+1:]
            x['dossier'] = getstr(data)
            data = data[len(x['dossier'])+1:]
            x['description'] = getstr(data)
            data = data[len(x['description'])+3:]
            x['player'] = ord(data[0])
            x['players'] = ord(data[1])
        return x
    def getstr(data):
        x = ''
        for c in range(len(data)):
            d = str(data[c])
            if d != '\x00':
                x += d
            else:
                break
        return x
    host = servergroup[s]['server'].split(':')
    serversock = socket(AF_INET, SOCK_DGRAM)
    serversock.settimeout(1)
    try:
        serversock.connect((host[0], int(host[1])))
        serversock.send('\xFF\xFF\xFF\xFF\x54\x53\x6F\x75\x72\x63\x65\x20\x45\x6E\x67\x69\x6E\x65\x20\x51\x75\x65\x72\x79\x00')
        d = serversock.recv(1400)[6:]
        serversock.close()
        info = getdata(d)
    except:
        info={}
    if info:
        servergroup[s]['name'] = info['hostname']
        servergroup[s]['dispo'] = (info['player'], info['players'])
        r = True
    else:
        servergroup[s]['name'] = servergroup[s]['server']
        r = False
    t = "(%i/%i)" % (servergroup[s]['dispo'][0], servergroup[s]['dispo'][1]) if r else "(Time out)"
    m = popuplib.find('redirection_server_menu_page_%i' % servergroup[s]['place'][0])
    m.modlineAll(servergroup[s]['place'][1], '->%i. %s %s' % (servergroup[s]['place'][1]-2, servergroup[s]['name'], t))
    m.update(es.getUseridList())

def updatemenu():
    if not str(saycmd) == '0' or not str(sendmenu) == '0':
        for s in servergroup:
            infoserveur(s)


def get_serverinfo():
    getserverinfo = threading.Thread(target=updatemenu)
    getserverinfo.start()
    gamethread.delayedname(20, 'redirection_updatemenu', get_serverinfo)

def player_disconnect(event_var):
    if servergroup:
        if event_var['userid'] in plist:
            plist.remove(event_var['userid'])
        gamethread.cancelDelayed('redirectionforce%s' % event_var['userid'])

def unload():
    gamethread.cancelDelayed('redirection_updatemenu')
    if es.exists('saycommand', str(saycmd)):
        es.unregsaycmd(str(saycmd))
    i = 1
    while i > 0:
        if popuplib.exists('redirection_server_menu_page_%i' % i):
            popuplib.delete('redirection_server_menu_page_%i' % i)
            i += 1
        else :
             i = 0





